; Scripts for TeamTalk5Classic
; Author:  Doug Lee
; the additional scenario
; The Author - Mihail Gordeev



include "hjconst.jsh"
include "MSAAConst.jsh"
include "TeamTalk5Classic.jsm"
Include "common.jsm" ; message file

Globals
String user,
String speaks,
String gRoom,
String sWinText,
String inform,
String msgChannel,
String talks,
String ourState,
String sVerb,
String ping,
String VoiceNone,
Int nMute,
Int nVerb,
Int nFlagEvent,
Int nFlagVoice,
Int nFlagPush,
Int nUpdatedChannel,
Int nUser,
Int iWnd,
Int nik,
String sRxTx

const
vk = ";",
BM_CLICK = 0x00F5,
verb=";",
RxTx= ";"

void function autoStartEvent()
let speaks = iniReadString ("GraphicRes013232", "567387604", "", GetActiveConfiguration() + ".jgf")
Let speaks =StringSegment (speaks, "|", 1)
let gRoom = iniReadString ("GraphicRes013232", "4108880933", "", GetActiveConfiguration() + ".jgf")
Let gRoom =StringSegment (gRoom, "|", 1)
Let inform = ""
Let ourState = ""
SendMessage (GetAppMainWindow (GetCurrentWindow ()), 274, 61488, 0)
Let iWnd = 61488
; Flag
Let nFlagEvent = 0
Let nFlagVoice = 0
Let nFlagPush = 0
Let nUpdatedChannel = 0
If GetWindowClass (GetFocus ()) == "SysTreeView32" Then
Say (StringChopRight (StringSegment (GetWindowName (GetRealWindow (GetFocus ())),  "-", 1), 6), ot_message)
Return true
EndIf
endFunction
globals
; A list of tree window handles.
	string roomtree___hwnds,
; A dictionary of storage structures by server tree window handle.
; Fields:
;	hwnd, client:  The window handle and MSAA client object for the tree.
;	nodes:  The raw list of node names at last check.
	object roomtree___trees,
; First and last childIDs in numerical order.
; Used for byAge navigation.
	int roomtree___firstID, int roomtree___lastID

script nextChat()
; Move to the next TeamTalk window containing a visible chat.
if !chat4__focusNext(1) then
	beep()
endIf
endScript

script prevChat()
; Move to the previous TeamTalk window containing a visible chat.
if !chat4__focusNext(-1) then
	beep()
endIf
endScript

globals
; Records for chat windows, by top-level window handle (Scripting.Dictionary object).
; Fields:
;	hTop: The top-level window (same as the key for this record).
;	hwnd, oDoc: The actual chat window and its RichEdit document object.
;	type: The type of the window: c=channel, p=private.
;	unit: The TOM_* text unit for moving among messages.
;	firstStart, firstIdx: The starting position and index of the first "real" message.
;	curStart: The starting position of the range for the current text unit.
;	range: A Range object set by chat4___messageIndex() and reused by chat4__messageText() to get message text.
;	rows: Current number of rows in the message text (see chat4___rows()).
; Note: The caller of this module manages a reviewMessageNumber field as well.
; TODO: That should be handled in here.
	object chat4___chats

object function chat4__record(/*?*/ handle hwnd)
; Get or make the record for the current or given chat.
; Allows fields to be filled in that were missed at first.
if !hwnd || hwnd == 0 then
	let hwnd = getFocus()
endIf
var handle hTop let hTop = getTopLevelWindow(hwnd)
if !hTop || !isWindowVisible(hTop) then
	return
endIf
var object rec let rec = chat4__winrecs__record(chat4___chats, hTop)
if !rec then
	return
endIf

; Build or finish the record.

; Top-level window and navigation unit.
if !rec.exists("hTop") then
	rec.add("hTop", hTop)
	; Messages appear to be considered paragraphs.
	rec.add("unit", 4)  ; TOMParagraph
endIf

; Chat window and chat type.
if !rec.exists("hwnd") then
	; First try for a channel window.
	let hwnd = findWindow(hTop, "RichEdit20W", "")
	if hwnd then
		rec.add("type", "c")
	else
		; Then for a private chat window.
		let hwnd = findWindow(hTop, "RichEdit20A", "")
		if hwnd then
			rec.add("type", "p")
		endIf
	endIf
	if !hwnd then
		chat4__winrecs__remove(chat4___chats, hTop)
		return
	endIf
	rec.add("hwnd", hwnd)
endIf

; Chat window's RichEdit interface.
var object o
if !rec.exists("oDoc") then
	let o = getRichEditDocument(hwnd)
	if !o then
		return
	endIf
	rec.add("oDoc", o)
else
	let o = rec("oDoc")
endIf

; Row count for chat.
if !rec.exists("rows") then
	rec.add("rows", chat4___rows(hwnd))
endIf

if !rec.exists("firstStart") then
	rec.add("firststart", 0)
	rec.add("curstart", 0)
endIf

; Set rec("firststart") if necessary and possible.
if !rec("firststart") then
	if chat4___size(rec("hwnd")) < 10 then
		return
	endIf
	var object oRange let oRange = o.Range(0, 0)
	var int safety let safety = 0
	oRange.Expand(rec("unit"))
	while oRange.End -oRange.Start < 4 && safety < 10
		oRange.Collapse(0)
		oRange.Move(rec("unit"), 1)
		oRange.Expand(rec("unit"))
		let safety = safety +1
	endWhile
	if safety >= 10 then
		rec.remove("firststart")   rec.add("firststart", 0)
		rec.remove("firstidx")   rec.add("firstidx", 0)
		;sayInteger(chat4___size(rec("hwnd")))
	else
		rec.remove("firststart")   rec.add("firststart", oRange.Start)
		rec.remove("firstidx")   rec.add("firstidx", oRange.getIndex(rec("unit")))
	endIf
endIf
return rec
endFunction

int function chat4__clean()
; Clean out invalid chat windows.
; Returns the number of windows removed
var int nremoved let nremoved = chat4__winrecs__clean(chat4___chats)
var string hwnds let hwnds = chat4__winrecs__list(chat4___chats)
if !hwnds then
	return 0
endIf
var int n let n = stringSegmentCount(hwnds, "|")
var int i let i = 1
var handle hwnd
while i <= n
	let hwnd = stringToHandle(stringSegment(hwnds, "|", i))
	if isWindowDisabled(hwnd) then
		chat4__winrecs__remove(chat4___chats, hwnd)
		let nremoved = nremoved +1
	endIf
	let i = i +1
endWhile
return nremoved
endFunction

void function roomtree___setFirstAndLastChildIDs(object o)
; Sets roomtree___firstID and roomtree___lastID, used for byAge navigation.
; Helper for roomtree__getMember().
var int childID let childID = o.accNavigate(NavDir_FirstChild, 0)
; This has to be the "oldest" childID because it represents the tree root,
; which is the first childID created.
let roomtree___firstID = childID
; We know the last ID can't be less than this...
var int maxID let maxID = roomtree___firstID +o.accmaxCount -1
; but without a loop, we can't know what the highest one really is.
while childID
	if childID > maxID then
		let maxID = childID
	endIf
	let childID = o.accNavigate(NavDir_Next, childID)
endWhile
let roomtree___lastID = maxID
endFunction

int function chat4__focusNext(int delta)
; Focus the next or previous chat.
; Delta should be 1 for next and -1 for previous.
chat4___registerAllChatWindows()
var string hwnds let hwnds = chat4__winrecs__list(chat4___chats, "n")
if !hwnds then
	return False
endIf
var handle hTop let hTop = getTopLevelWindow(getFocus())
if !hTop then
	return False
endIf
var int idx let idx = stringSegmentIndex(hwnds, "|", intToString(hTop), True)
var int n let n = stringSegmentCount(hwnds, "|")
if !idx then
	if delta > 0 then
		let idx = n
	else
		let idx = 1
	endIf
endIf
let idx = idx +delta
if idx < 1 then
	let idx = idx +n
elif idx > n then
	let idx = idx -n
endIf
var handle hwnd let hwnd = stringToHandle(stringSegment(hwnds, "|", idx))
if hwnd == hTop then
	sayMessage(OT_Error, chat4___msgNoMoreWindows)
	return True
endIf
setFocus(hwnd)
var int safety let safety = 50
while safety
	if getTopLevelWindow(getFocus()) == getTopLevelWindow(hwnd) then
		let safety = 1
	elif !getFocus() && getForegroundWindow() == getTopLevelWindow(hwnd)
	&& MSAA__windowState(getForegroundWindow(), 0, ObjID_Window) & State_System_Invisible then
		typeKey("Enter")
		let safety = 1
	else
		pause()
	endIf
	let safety = safety -1
endWhile
return True
endFunction

void function chat4___registerAllChatWindows()
; Build or update the list of all valid chat windows.
var string thisOwner let thisOwner = getWindowOwner(getTopLevelWindow(getFocus()))
var handle hwnd let hwnd = findTopLevelWindow("#32770", "")
while hwnd
	if isWindowVisible(hwnd) && !isWindowDisabled(hwnd)
	&& stringCompare(getWindowOwner(hwnd), thisOwner, True) == 0 then
		chat4__record(hwnd)
	endIf
	let hwnd = getNextWindow(hwnd)
endWhile
chat4__clean()
endFunction

const
; The hash key used to store the list of window handles,
; because JAWS can't use the keys() method of Scripting.Dictionary objects.
	chat4__winrecs___HwndListKey = "__hwnds__"


object function chat4__winrecs__record(object byRef recs, handle hwnd)
; Return the record for the given window.
; Registers this window in the set if necessary.
; Also removes stale records for windows that no longer exist.
; The caller must handle record structure creation.
; Suggestion: Use an "hwnd" property so there's a uniform way to test for a new record.
chat4__winrecs__clean(recs)
if !hwnd then
	return
endIf
var string shwnd let shwnd = intToString(hwnd)
var object rec
if !recs then
	let recs = util__newCollection()
endIf
if !recs.exists(shwnd) then
	; We have to make a new record for this one.
	var string hwnds let hwnds = recs(chat4__winrecs___HwndListKey)
	if !hwnds then
		let hwnds = shwnd
	else
		let hwnds = formatString("%1|%2", hwnds, shwnd)
	endIf
	recs.remove(chat4__winrecs___HwndListKey)
	recs.add(chat4__winrecs___HwndListKey, hwnds)
	let rec = util__newCollection()
	recs.add(shwnd, rec)
	; Caller must detect that this record is empty and build it.
else
	let rec = recs(shwnd)
endIf
return rec
endFunction

int function chat4__winrecs__clean(object recs)
; Remove from recs any records for windows that no longer exist.
; Returns the number of records removed.
var string hwnds let hwnds = recs(chat4__winrecs___HwndListKey)
var int n let n = stringSegmentCount(hwnds, "|")
var int nremoved let nremoved = 0
var string shwnd, handle hwnd
while n
	let shwnd = stringSegment(hwnds, "|", n)
	let hwnd = stringToHandle(shwnd)
	if !getWindowStyleBits(hwnd) then
		if chat4__winrecs__remove(recs, hwnd) then
			let nremoved = nremoved +1
		endIf
	endIf
	let n = n -1
endWhile
return nremoved
endFunction

int function chat4___size(handle hwnd)
; Return the "size" of the material in the given message area window.
return sendMessage(hwnd, 0x0E, 0, 0)  ; WM_GetTextLength
endFunction

string function chat4__winrecs__list(object recs, /*?*/ string how)
; Return a |-delimited list of the registered window handles.
; By default, handles are returned in the order in which they were added to the set.
; If how is "n", they are returned in numeric order.
; If how is anything else, it is considered a function name or call.
; See util__compare() for details.
var string hwnds let hwnds = recs(chat4__winrecs___HwndListKey)
if !how then
	return hwnds
endIf
; Kludge: Make XList out of hwnds.
let hwnds = "|" +hwnds +"|"
let hwnds = chat4__winrecs__xlist__sort(hwnds, how, False)
; Remove the extra delimiters added above.
let hwnds = stringChopLeft(stringChopRight(hwnds, 1), 1)
return hwnds
endFunction

string function chat4__winrecs__xlist__sort(string xl, string how, int sortDescending)
; Sorts xl and returns the result.
; How is as for util__compare().
; This is a stable sort; equal items are not swapped.
; TODO:  The algorithm is slow:  sorting 200 items took nine seconds on a Sony Vaio 1.2 GHz Centrino machine (Windows XP, JAWS 7.10, DGL, 2006-08-25).
var
	string xl1,
	string tmp, string firstVal, int firstIdx,
	int i, int n, int cmp
; Using the below trick instead of chat4__winrecs__xlist__new() preserves the separator from xl on return.
let xl1 = stringLeft(xl, 1)
let n = chat4__winrecs__xlist__itemCount(xl)
if !n then
	return xl1
elif n == 1 then
	; The commented-out approach guarantees an XList structure return;
	; the faster plan, in effect, allows single-item strings to pass through unchecked.
	;chat4__winrecs__xlist__addItem(xl1, chat4__winrecs__xlist__getItem(xl, 1))
	;return xl1
	return xl
endIf

; We have two or more items.
while n > 1
	let firstVal = chat4__winrecs__xlist__getItem(xl, 1)
	let firstIdx = 1
	let i = 2
	while i <= n
		let tmp = chat4__winrecs__xlist__getItem(xl, i)
		let cmp = util__compare(firstVal, tmp, how)
		if sortDescending then
			let cmp = cmp * (-1)
		endIf
		if cmp > 0 then
			let firstVal = string__ref(tmp)
			let firstIdx = i
		endIf
		let i = i +1
	endWhile
	; firstVal and firstIdx are the value and index of the "first" value, respectively.
	; "First" means smallest for ascending and greatest for descending sorts.
	chat4__winrecs__xlist__addItem(xl1, firstVal)
	chat4__winrecs__xlist__delete(xl, firstIdx, 1)
	let n = n -1
endWhile
; What's left is the max item.
chat4__winrecs__xlist__addItem(xl1, chat4__winrecs__xlist__getItem(xl, 1))
return xl1
endFunction

int function chat4__winrecs__xlist__itemCount(string lst)
; Returns the number of items in lst.
; If lst is not a proper XList, returns 0.
if !stringLength(lst) then
	return 0
endIf
return string__segmentCount(lst, stringLeft(lst, 1)) -2
endFunction



variant function chat4__winrecs__xlist__getItem(string lst, int i)
; Returns the ith element of lst.
; If i is greater than the item count, the null string is returned.
var string val
if i < 1 || !stringLength(lst) then
	return ""
endIf
let val = stringSegment(lst, stringLeft(lst, 1), i+1)
return val
endFunction

int function chat4__winrecs__xlist__addItem(string byRef lst, variant item)
; Append item to lst.
; If lst is null, it will be created first; but if it is non-null and not an XList, a mess is likely.
; Returns True on success and False on failure.
; On failure, lst is not changed (except for maybe being initialized if null).
if !stringLength(item) && item then
	sayMessage(OT_No_Disable, "Can't store an object in an XList")
	return False
endIf
if !chat4__winrecs__xlist___settleDelim(lst, item, 1) then
	return False
endIf
let lst = string__cat(lst, string__cat(item, stringLeft(lst, 1)))
return True
endFunction

int function chat4__winrecs__xlist__delete(string byRef lst, int i, int n)
; Deletes n elements starting at element i.
var
	int pos1, int pos2
let pos1 = chat4__winrecs__xlist___indexPos(lst, i)
if !pos1 || pos1 == stringLength(lst)+1 then
	return False
endIf
let pos2 = chat4__winrecs__xlist___indexPos(lst, i+n)
if !pos2 || pos2 == stringLength(lst)+1 then
	let lst = stringLeft(lst, pos1-1)
	return True
endIf
let lst = string__cat(stringLeft(lst, pos1-1), stringChopLeft(lst, pos2-1))
return True
endFunction

int function chat4__winrecs__xlist___indexPos(string lst, int i)
; Returns the character position in lst of the first character of the ith element.
; Returns 0 if there is no such element.
; Exception:  If i == itemCount+1, returns stringLength(lst)+1.
var
	string delim,
	int len,
	int pos,
	int result
if i < 1 then
	return 0
endIf
let delim = stringLeft(lst, 1)
let len = stringLength(lst)
if !len then
	return 0
elif len == 1 then
	return 1
endIf
let result = 0
while i
	let pos = stringContains(lst, delim)
	if !pos then
		return 0
	endIf
	let result = result +pos
	let lst = stringChopLeft(lst, pos)
	let i = i -1
endWhile
return result +1
endFunction

int function chat4__winrecs__xlist___settleDelim(string byRef lst, string item, int dlen)
; Internal function to manage the changing of delimiters as needed.
; Must be called whenever material is being added to an XList.
; dlen is the length of lst's current delimiter (1 except when sent via fromJAWSList).
; Returns True if a valid delimiter is in place on exit and False if there is no safe delimiter available.
; A "valid" delimiter is a one-character delimiter not found in lst (except as the current delimiter) or item.
var
	string delim,
	int c0, int c, string ch,
	int done
if !stringLength(lst) then
	let lst = chat4__winrecs__xlist__new()
endIf
let delim = stringLeft(lst, dlen)
if stringContains(item, delim) || dlen != 1 then
	let c = chat4__winrecs__xlist__charToANSI(stringLeft(lst, 1))
	let c0 = c
	let done = False
	while !done
		let c = c +1
		if c > 254 then
			; 255 may not write correctly to a file, and 0 is not possible in JAWS.
			let c = 1
		elif c >= 8 && c <= 13 then
			; backspace, tab, LF, RF(?), FF, CR:
			; These characters are unfriendly when written to a text file, so they are avoided.
			let c = 14
		elif c == 26 || c == 27 then
			; DOS/Windows EOF, ESC
			let c = 28
		endIf
		let ch = chat4__winrecs__xlist__charFromANSI(c)
		if c == c0 then
			; We've come all the way around; there is no safe delimiter for this situation.
			beep()
			sayMessage(OT_No_Disable, "xlist:  Out of delimiters")
			return False
		elif !stringContains(lst, ch) && !stringContains(item, ch) then
			; We have a winner!
			chat4__winrecs__xlist___setDelim(lst, ch, dlen)
			let delim = ch
			let done = True
		endIf
	endWhile
endIf
return True
endFunction

int function util__compare(variant v1, variant v2, string how)
; Comparison that returns 1 if v1 is greater than v2, 0 if equal to v2, and -1 if less than v2.
; Comparison types (values of how):
;	n - Numeric comparison (non numbers sort as 0).
;	i - Case-insensitive string comparison.
;	s (default if how is null) - Case-sensitive string comparison.
;	<funcName> - Returns funcname(v1, v2)
;	<funcCall> - Evaluates funcCall substituting %1 with "v1" and %2 with "v2."
; TODO:  Beeps and returns 0 in the following cases:
;	- String comparison (how == i or s) for JAWS versions older than 6.20.
;	- Function calls (funcName or funcCall) when v1 or v2 contains a quote (").
var
	int jver
let jver = util__getJFWVersion()
if !how then
	let how = "s"
endIf
if stringLength(how) == 1 then
	if how == "n" then
		if stringToInt(v1) == stringToInt(v2) then
			return 0
		elif stringToInt(v1) < stringToInt(v2) then
			return -1
		else
			return 1
		endIf
	elif how == "s" || how == "i" then
		if jver >= 620000 && !util__isPACMate() then
			return stringCompare(v1, v2, (how == "s"))
		else
			; TODO: Not supported and no good way to indicate it.
			beep()
			return 0
		endIf
	endIf
endIf
if stringContains(v1, "\"") || stringContains(v2, "\"") then
	; Incompatible with formatStringWithEmbeddedFunctions().
	beep()
	return 0
endIf
if stringContains(how, "(") then
	string__replace(how, "%1", "\""+string__ref(v1)+"\"", "e")
	string__replace(how, "%2", "\""+string__ref(v2)+"\"", "e")
	return stringToInt(formatStringWithEmbeddedFunctions("<" +how +">"))
endIf
return stringToInt(formatStringWithEmbeddedFunctions("<" +how +"(\"" +string__ref(v1) +"\", \"" +string__ref(v2) +"\")>"))
endFunction

string function string__ref(variant v)
; Type cast from anything to string.
; Useful for allowing object results to be included in string concatenations without a compile-time error.
return v
endFunction


string function string__cat(string s1, string s2)
; Safe string concatenator.
return stringChopLeft(" " +s1 +s2, 1)
endFunction


int function string__segmentCount(string s, string sep)
; Returns the number of segments in the given string.
; If sep is null, the result is 0.
; As of 03/15/03, the null string is defined to have zero segments (previously one).
; Any non-null string containing no separators has one segment.
; WARNING: Unlike the built-in (as of JAWS 7.0) stringSegmentCount function,
; this function counts the null string after a trailing delimiter;
; thus, string__segmentCount("a|b|", "|") is 3, where JAWS would say 2.
; Also, this function considers a multi-character sep as a multi-character delimiter,
; whereas stringSegmentCount allows each character of sep to be a delimiter.
var
	int len,
	int seplen,
	int l,
	int n
let seplen = stringLength(sep)
if util__getJFWVersion() >= 700000 && seplen == 1 then
	let n = stringSegmentCount(s, sep)
	if stringRight(s, 1) == sep then
		; JAWS does not count the null string after a trailing delimiter, but I do.
		let n = n +1
	endIf
	return n
endIf
let len = stringLength(s)
if !len then
	return 0
endIf
if !seplen then
	return 0
endIf

; A little optimization made possible by JAWS 6.0's StringReplaceSubstrings function...
if util__getJFWVersion() >= 600000 && !util__isPACMate() then
	; Count segments by removing all separators and comparing string lengths.
	let l = stringLength(string__ref(stringReplaceSubstrings(s, sep, "")))
	let l = len -l
	return (l / seplen) +1
endIf

let n = 0
let l = 0
while True
	let n = n+1
	let l = l +stringLength(stringSegment(s, sep, n)) +seplen
	if l > len then
		return n
	endIf
endWhile
; this line is never reached; even a null string will return 1 (it's a single null segment :-).
endFunction

globals
	int util___JAWSVer

int function util__getJFWVersion()
; GetJFWVersion with caching to make it faster.
; Also includes the build number even when GetJFWVersion() does not.
var
	string js
if !util___JAWSVer then
	let util___JAWSVer = getJFWVersion()
	let js = intToString(util___JAWSVer)
	if stringRight(js, 3) == "000" then
		let js = util__getJAWSInfo()
		let js = stringSegment(js, "|", 1)
		let js = stringSegment(js, ".", 3)
		let util___JAWSVer = util___JAWSVer +stringToInt(js)
	endIf
endIf
return util___JAWSVer
endFunction

int function chat4__winrecs__remove(object recs, handle hwnd)
; Remove a window's record.
var string shwnd let shwnd = intToString(hwnd)
if !recs.exists(shwnd) then
	return False
endIf
recs.remove(shwnd)
var string hwnds let hwnds = recs(chat4__winrecs___HwndListKey)
if !string__segmentRemove(hwnds, "|", shwnd) then
	chat4__winrecs__log__write("Failed to remove handle " +shwnd +" from the window list.")
	return True
endIf
recs.remove(chat4__winrecs___HwndListKey)
recs.add(chat4__winrecs___HwndListKey, hwnds)
return True
endFunction

int function chat4___rows(handle hwnd)
; Return the number of rows of material in the given message window.
; This is used to detect changes.
var int lcount let lcount = sendMessage(hwnd, 0xBA, 0, 0)  ; EM_GetLineCount
return lcount
endFunction

int function ReadMsg(variant which, int isReviewSystem)
; Which should be +n (n forward), -n (n backward), n (message #n), "L" (last), or "C" (current).
var
	int msgno,
	int messageCount,
	int isJoinOrLeave,
	string buf
var object rec let rec = chat4__record()
let msgno = rec("reviewMessageNumber")

; First deal with room switches.
let messageCount = chat4__messageCount()
if messageCount < 0 then
	sayMessage(OT_Error, msgMessageError)
	return False
endIf
if !messageCount then
	let msgno = 0
	sayMessage(OT_User_Requested_Information, msgNoMessages)
	if isReviewSystem then
		rec.remove("reviewMessageNumber")
		rec.add("reviewMessageNumber", msgno)
	endIf
	return False
elif msgno < 1 then
	let msgno = 1
elif msgno > messageCount then
	let msgno = messageCount
endIf

if which == "L" then
	let msgno = messageCount
elif which == "C" then
	; Do nothing; leave msgno as is.
elif stringContains("+-", stringLeft(which, 1)) then
	let msgno = msgno +stringToInt(which)
else
	let msgno = stringToInt(which)
endIf

; Say the message after possible translation for welcome/goodbye style.
let buf = chat4__messageText(msgno)
applyChatTimePreference(buf)
let isJoinOrLeave = False

; the isReviewSystem part allows manually-requested messages to speak under all conditions.
var int chCycler let chCycler = 0
if isReviewSystem || !ChCycler || (ChCycler == 1 && isJoinOrLeave) || (ChCycler == 2 && !isJoinOrLeave) || (ChCycler == 3 && isJoinOrLeave) then
	if which == "c" then
		var string buf1 let buf1 = formatString(msgMessagePos, intToString(rec("reviewMessageNumber")), intToString(messageCount))
		let buf = formatString("%1: %2", buf1, buf)
	endIf
	sayMessage(OT_User_Requested_Information, buf)
elif !isReviewSystem && !isJoinOrLeave && (ChCycler == 3 || ChCycler == 4) then
	scheduleFunction("PlayMessageSound", 2)
endIf

if msgno < 1 then
	let msgno = 1
elif msgno > messageCount then
	let msgno = messageCount
endIf
if isReviewSystem then
	rec.remove("reviewMessageNumber")
	rec.add("reviewMessageNumber", msgno)
endIf
return True
endFunction
int function chat4__messageCount(/*?*/ handle hwnd)
; Returns the number of messages in the buffer.
; A return of -1 indicates an error.
; TODO: Error checking is not here yet.
var object rec let rec = chat4__record(hwnd)
return chat4___messageIndex(-1, rec)
endFunction

int function chat4__messageIndex(/*?*/ handle hwnd)
; Returns the 1-based index of the last-read message.
var object rec let rec = chat4__record(hwnd)
return chat4___messageIndex(rec("curstart"), rec)
endFunction

int function chat4___messageIndex(int start, /*?*/ variant which)
; Return the 1-based index of the message whose start position is given, or 0 on failure..
; A start position of -1 means the last message.
; Blank lines at the top and bottom of the buffer are avoided.
; Which can bbe a window handle, a record object, or omitted.
; This function is also used internally to set the rec("range") object.
var object rec
if !which then
	; Record for currently focused chat.
	let rec = chat4__record()
elif intToString(which) then
	; Record for given window handle.
	let rec = chat4__record(which)
else
	; Record was passed directly.
	let rec = which
endIf
if !rec then
	return 0
endIf

var object oRange
if start == -1 then
	; Find the end of the buffer.
	let oRange = rec("oDoc").Range(0, 0)
	oRange.Expand(6)  ; 6 is TOMStory
	; A blank line tends to remain at the end of the buffer.
	; -2 here avoids it.
	let start = oRange.End -2
endIf
; This avoids the blank line before the first message.
if start < rec("firststart") then
	let start = rec("firststart")
endIf
let oRange = rec("oDoc").Range(start, start)
oRange.Expand(rec("unit"))
rec.remove("range")   rec.add("range", oRange)
return oRange.getIndex(rec("unit")) -rec("firstidx") +1
endFunction

string function chat4__messageText(/*?*/ int idx, handle hwnd)
; Return the text of the current or indicated message.
; Negative numbers index from the end.
; The current message position is not changed.
var object rec let rec = chat4__record(hwnd)
var string txt
if idx then
	if idx < 0 then
		chat4___messageIndex(-1, rec)
		; sets rec("range") to the last message.
		if idx != -1 then
			chat4___move(idx+1, rec)
		endIf
	else  ; positive idx.
		chat4___messageIndex(rec("firststart"), rec)
		; sets rec("range") to the first message.
		if idx != 1 then
			chat4___move(idx-1, rec)
		endIf
	endIf
else
	; Current message wanted.
	chat4___messageIndex(rec("curstart"), rec)
	; rec("range") set and we don't have to move anywhere from here.
endIf
let txt = rec("range").Text
return stringTrimLeadingBlanks(stringTrimTrailingBlanks(txt))
endFunction

int function applyChatTimePreference(string byRef buf)
; Strip out the message time if requested by the user option for this.
if opt__get("chatMessageTimes") then
	return False
endIf
var int pos let pos = stringContains(buf, " ")
var string maybeTime let maybeTime = stringLeft(buf, pos-1)
if stringContains(maybeTime, ":")
&& stringContains("0123456789", stringLeft(maybeTime, 1))
&& stringContains("0123456789", stringRight(maybeTime, 1))
then
	let buf = stringChopLeft(buf, pos)
	return True
endIf
return False
endFunction

const
; A constant used to detect missing, as opposed to set-to-empty, .ini keys.
	opt___NoVal = 12345678

globals
; Information maintained by this module.
	object opt___data

void function opt__init(/*?*/ string sectname, string filename)
; Set the section and file names used by this module for storing options.
if !opt___data then
	let opt___data = util__newCollection()
endIf
opt___setVal("sectname", sectname, "Options")
opt___setVal("filename", filename, getActiveConfiguration()+".ini")
endFunction

void function opt___setVal(string name, string val, string dfl)
; Sets an internal configuration option to a given or default value.
; Helper for opt__init().
var string curval let curval = opt___data(name)
if !val && !curval then
	let val = dfl
endIf
if val then
	opt___data.remove(name)
	opt___data.add(name, val)
endIf
endFunction

variant function opt__get(string varName)
; Retrieves and returns the value of the indicated user-settable variable from the ini file for these scripts.
; This function makes sure to return integer 0 for the integer value 0, rather than returning the string "0" which shows up as True in a boolean test.
; varName: The name of the option to retrieve.
var
	string val
opt__init()
; Chop off descriptions.
let varname = stringSegment(varname, ":", 1)
let val = iniReadString(opt___data("sectname"), varname, intToString(opt___NoVal), opt___data("filename"))
; Favor integer 0 (False) rather than string "0" (True).
if stringContains(stringLeft(stringTrimLeadingBlanks(val), 1), "0") then
	return ""
endIf
if val == opt___NoVal then
	; All default values for options go here.
	if varname == SV_SpeakChatMessages then
		let val = "1"
	elif varname == SV_ChatMessageTimes then
		let val = "1"
	else
		let val = ""
	endIf
endIf
return val
endFunction

int function chat4___move(int delta, /*?*/ object rec)
; Move delta messages from the current position of rec("range").
; rec("range") must be set first.
; Note that this is from rec("range"), not rec("curstart").
; Returns the distance moved.
if !delta then
	return 0
endIf
if !rec then
	let rec = chat4__record()
	if !rec then
		return 0
	endIf
endIf
var int curidx let curidx = chat4___messageIndex(rec("range").Start, rec)
rec("range").Collapse(-1)  ; -1 is TOMTrue, for collapse to start.
if chat4___trimDelta(delta, curidx, rec) then
	beep()
endIf
rec("range").Move(rec("unit"), delta)
rec("range").Expand(rec("unit"))
var int result let result =
util__abs(curidx -chat4___messageIndex(rec("range").Start))
return result
endFunction

int function chat4___trimDelta(int byRef delta, int curidx, object rec)
; Forces delta not to move outside the valid messages.
; Returns True if delta is changed and False if not.
if delta < 0 then
	if curidx+delta < 1 then
		let delta = 1-curidx
		return True
	endIf
else
	var object oRange let oRange = rec("range").duplicate()
	var int lastidx let lastidx = chat4___messageIndex(-1, rec)
	rec.remove("range")   rec.add("range", oRange)
	if curidx +delta > lastidx then
		let delta = lastidx -curidx
		return True
	endIf
endIf
return False
endFunction

int function util__abs(int n)
; Return the absolute value of n.
if n < 0 then  return 0-n
else return n
endIf
endFunction

Script ReadFirstMessage()
ReadMsg("1", True)
EndScript

Script ReadLastMessage()
ReadMsg("L", True)
EndScript

Script ReadNextMessage()
ReadMsg("+1", True)
EndScript

Script ReadPriorMessage()
ReadMsg("-1", True)
EndScript

Script ReadCurrentMessage()
var object rec let rec = chat4__record()
var string buf let buf = chat4__messageText(rec("reviewMessageNumber"))
applyChatTimePreference(buf)
if isSameScript() then
	spellString(buf)
else
	ReadMsg("c", True)
endIf
EndScript

script readAbsoluteMessage(int idx)
if idx < 0 then
	let idx = chat4__messageCount() +idx +1
endIf
readMsg(idx, False)
endScript

script ControlUpArrow()
if isPCCursor() && getFocus() && getFocus() == roomtree__currentTreeWindow() then
	roomtree__move("prev", False)
	return
endIf
performScript ControlUpArrow()
endScript

script controlDownArrow()
if isPCCursor() && getFocus() && getFocus() == roomtree__currentTreeWindow() then
	roomtree__move("next", False)
	return
endIf
performScript controlDownArrow()
endScript

script prevByAge()
if isPCCursor() && getFocus() && getFocus() == roomtree__currentTreeWindow() then
	roomtree__move("prev", True)
	return
endIf
sayCurrentScriptKeyLabel()
typeCurrentScriptKey()
endScript

script nextByAge()
if isPCCursor() && getFocus() && getFocus() == roomtree__currentTreeWindow() then
	roomtree__move("next", True)
	return
endIf
sayCurrentScriptKeyLabel()
typeCurrentScriptKey()
endScript

script topOfFile()
if isPCCursor() && getFocus() && getFocus() == roomtree__currentTreeWindow() then
	roomtree__move("first", False)
	return
endIf
performScript topOfFile()
endScript

script bottomOfFile()
if isPCCursor() && getFocus() && getFocus() == roomtree__currentTreeWindow() then
	roomtree__move("last", False)
	return
endIf
performScript bottomOfFile()
endScript

script selectFromTop()
if isPCCursor() && getFocus() && getFocus() == roomtree__currentTreeWindow() then
	roomtree__move("first", True)
	return
endIf
performScript selectFromTop()
endScript

script selectToBottom()
if isPCCursor() && getFocus() && getFocus() == roomtree__currentTreeWindow() then
	roomtree__move("last", True)
	return
endIf
performScript selectToBottom()
endScript

globals
string roomtree___hwnds,
object roomtree___trees,
int roomtree___firstID, int roomtree___lastID

int function roomtree__reportMemberships(int includeList, /*?*/ int startNode)
; Report who is where in the current TeamTalk server's channel tree.
; includeList: True to include names, False to show only counts per channel.
; TODO: This function is not fully written.
var object tree let tree = roomtree___treeRecord()
if !tree then
	sayMessage(OT_Error, roomtree___msgNoTree)
	return False
endIf
var object o let o = tree("client")
if !startNode then
	; Start on the root node.
	let startNode = 1
endIf
var string names let names = ""
var int childID let childID = o.accNavigate(7, startNode)  ; 7 is NavDir_FirstChild
var int safety let safety = 1000
var string name, int memberCount
while childID && safety
	roomtree___getNameAndCount(o.accName(childID), name, memberCount)
	if includeList then
		if memberCount == -1 then
			; A member, not a channel.
		endIf
	else
	endIf
	let childID = o.accNavigate(2, childID)  ; 2 is NavDir_Down
	let safety = safety -1
endWhile
; Safety ran out; a bad thing.
beep()
return False
endFunction

object function roomtree___treeRecord(/*?*/ handle hwnd)
; Returns the record for the given or currently focused TeamTalk's channel tree.
; Registers this tree in roomtree___trees if necessary.
; Also removes stale records for windows that no longer exist.
; Does not update the record itself from the tree.
roomtree___cleanOutStaleWindows()
var variant null
if !hwnd then
	let hwnd = roomtree__currentTreeWindow()
	if !hwnd then
		return
	endIf
endIf
var string shwnd let shwnd = intToString(hwnd)
var object tree, object o, int childID
if !roomtree___trees.exists(shwnd) then
	; We have to make a new record for this one.
	let o = getObjectFromEvent(hwnd, -4, 0, childID)  ; -4 is ObjID_Client
	if !o then
		return False
	endIf
	let roomtree___hwnds = formatString("%1|%2", roomtree___hwnds, shwnd)
	let tree = util__newCollection()
	if !roomtree___trees then
		let roomtree___trees = util__newCollection()
	endIf
	roomtree___trees.add(shwnd, tree)
	tree.add("hwnd", hwnd)
	tree.add("client", o)
	tree.add("nodes", util__newCollection())
else
	let tree = roomtree___trees(shwnd)
endIf
return tree
endFunction

int function roomtree___cleanOutStaleWindows()
; Remove from roomtree___trees any records for windows that no longer exist.
; Returns the number of records removed.
var int n let n = stringSegmentCount(roomtree___hwnds, "|")
var int nremoved let nremoved = 0
var string shwnd
while n
	let shwnd = stringSegment(roomtree___hwnds, "|", n)
	if getWindowClass(stringToHandle(shwnd)) != "SysTreeView32" then
		let nremoved = nremoved +1
		roomtree___trees.remove(shwnd)
		if !string__segmentRemove(roomtree___hwnds, "|", shwnd) then
			chat4__winrecs__log__write("Failed to remove handle " +shwnd +" from the tree list.")
		endIf
	endIf
	let n = n -1
endWhile
return nremoved
endFunction

handle function roomtree__currentTreeWindow()
; Return the handle of the channel tree for the focused TeamTalk instance,
; or return null on error.
var handle hwnd let hwnd = ttutil__mainWindow()
if !hwnd then
	return 0
endIf
let hwnd = findWindow(hwnd, "SysTreeView32", "")
if !hwnd then
	return 0
endIf
return hwnd
endFunction

handle function ttutil__mainWindow()
; Return the main top-level TeamTalk window.
var handle hwnd let hwnd = getTopLevelWindow(getFocus())
if ttutil__isMainWindow(hwnd) then
	return hwnd
endIf
let hwnd = findTopLevelWindow("#32770", "")
while hwnd
	if ttutil__isMainWindow(hwnd) then
		return hwnd
	endIf
	let hwnd = getNextWindow(hwnd)
endWhile
return hwnd   ; null
endFunction

int function ttutil__isMainWindow(handle hwnd)
; Returns True if and only if hwnd is the main top-level TeamTalk window.
if getWindowClass(hwnd) == "#32770"
&& stringContains(getWindowName(hwnd), ttutil__scMainWindowName) then
	return True
endIf
return False
endFunction

int function roomtree__move(string which, int byAge)
; Move to another member node.
; Returns True on success and False on failure.
var int childID let childID = roomtree__getMember(0, which, byAge, True)
if !childID then
	return False
endIf
var object tree let tree = roomtree___treeRecord()
if !tree then
	return False
endIf
var object o let o = tree("client")
var int focusID let focusID = o.accFocus +0
if childID == focusID then
	; The indirect call avoids compilation problems before JAWS 8,
	; which are otherwise caused by the passing of a parameter.
	; The parameter avoids position info announcement like "1 of 6."
	beep()
	formatStringWithEmbeddedFunctions("<sayObjectActiveItem(0)>")
else
	; Leaving out SelFlag_TakeFocus avoids the following anomaly:
	; Focus remains, in MSAA and by window, on the right thing,
	; but Alt doesn't work, Alt+F4 destroys the tree leaving the app running,
	; and Tab and then Alt+F4 causes a busy loop terminated only by Alt+Tab.
	; Using TakeFocus+TakeSelection but calling AccSelect twice solves
	; the menu problem but causes the loop issue to occur on Alt+F4 without Tab.
	o.accSelect(SelFlag_TakeSelection, childID)
	if stringCompare(roomtree___treePath(o, childID), roomtree___treePath(o, focusID), True) != 0 then
		roomtree___sayNode()
	endIf
endIf
return True
endFunction
int function roomtree__getMember(int childID, string which, /*?*/ int byAge, int alsoSpeak)
; Get the child ID of a member based on which and, if passed, byAge.
; "Member" means person, as opposed to channel.
; If childID is 0 or invalid, starts as appropriate from an end of the list or the current position.
; If byAge is False or not passed, uses tree order.
; If byAge is True, attempts to order members chronologically by when they last joined a channel.
; If alsoSpeak is True, speaks error messages as appropriate.
; Values of which:
;	first, last: First or last member.
;	next, prev: Next or previous member from given position.
;	nextCyclic, prevCyclic: Same but looping around the member list.
; On success, returns the childID of the member sought.
; On error, returns 0.
var object tree let tree = roomtree___treeRecord()
if !tree then
	if alsoSpeak then
		sayMessage(OT_Error, roomtree___msgNoTree)
	endIf
	return False
endIf
var object o let o = tree("client")
if byAge then
	roomtree___setFirstAndLastChildIDs(o)
endIf

; Handle next/prev requests, or if appropriate, make first/last requests out of them.
if which == "next" || which == "prev" then
	if !childID then
		let childID = o.accFocus
	endIf
	if childID then
		let childID = roomtree___navNext(o, childID, (which == "next"), byAge, True)
	endIf
	if !childID then
		; No current position or no next one,
		; so these become first/last requests in cyclic mode.
		; They also do this if no node is focused yet,
		; which happens when a server connection is first opened.
		if !stringContains(stringLower(which), "cyclic") && o.accFocus then
			if alsoSpeak then
				sayMessage(OT_Error, roomtree___msgNoMoreMembers)
			endIf
			return 0
		endIf
		if which == "next" then
			let which = "first"
		else  ; prev
			let which = "last"
		endIf
	endIf
endIf

; Handle first and last, both by tree and by age.
if which == "first" then
	; The first childID is also the oldest.
	let childID = o.accNavigate(NavDir_FirstChild, 0)
	let childID = roomtree___navNext(o, childID, True, byAge, False)
elif which == "last" then
	if byAge then
		let childID = roomtree___lastID
	else
		let childID = o.accNavigate(NavDir_LastChild, 0)
	endIf
	let childID = roomtree___navNext(o, childID, False, byAge, False)
endIf
if !childID then
	if alsoSpeak then
		sayMessage(OT_Error, roomtree___msgNoMembers)
	endIf
endIf
return childID
endFunction

int function string__segmentRemove(string byRef s, string sep, string r)
; Removes the first segment in s that exactly matches r, including case.
; Removes or leaves segment separators as appropriate.
; TODO: string__segmentRemove(s, "|", "val") is identical for s = "val" or "|val" or "val|":  the null string.
; Returns True if a segment is removed and False otherwise.
; Tested thoroughly for all segmentation and null cases 09/16/03.
var
	int slen, int seplen, int rlen, int pos
if !s || !sep || !r then
	return False
endIf

; Cases of s: (1) no r, (2) r, (3) r+sep+right, (4) left+sep+r, (5) left+sep1+r+sep2+right.
let slen = StringLength(s)
let seplen = StringLength(sep)
let rlen = stringLength(r)
let pos = stringContains(s, sep+r+sep)
if pos then
	; (5):  Most common case: r is in the middle of s somewhere, not at beginning or end.
	; This changes left+sep1+r+sep2+right to left+sep2+right.
	; pos currently points to the first character of sep1.
	let s = stringLeft(s, pos-1) +stringChopLeft(s, pos+seplen+rlen-1)
	return True
elif stringContains(s, r) == 1 then
	if slen == rlen then
		; (2) s is exactly r.
		let s = ""
		return True
	elif slen >= rlen+seplen && substring(s, rlen+1, seplen) == sep then
		; (3) s is r+sep+right (right may be null).
		let s = stringChopLeft(s, rlen+seplen)
		return True
	endIf
elif stringContains(stringRight(s, seplen+rlen), sep+r) then
	; (4):  s is left+sep+r (left may be null).
	let s = stringChopRight(s, seplen+rlen)
	return True
endif

; (1):  s does not contain r.
return False
endFunction

globals
; FileSystemObject and log stream object obtained from it.
	object chat4__winrecs__log___fso,
	object chat4__winrecs__log___logstream,
; Name of file.
	string chat4__winrecs__log___fileName,
	int chat4__winrecs__log___canCreate,
	string chat4__winrecs__log___userID,
	string chat4__winrecs__log___machineID

int function chat4__winrecs__log__write(string s, /*?*/ int alsoSpeak)
; Write a string to the log file, and also optionally speak it.
if alsoSpeak then
	sayMessage(OT_Error, s)
endIf
if !chat4__winrecs__log__isOpen() then
	return False
endIf
if !chat4__winrecs__log___open() then
	return False
endIf
var string buf let buf = formatString(
	"*** %1 %2@%3 (%4)\n%5:\n",
	chat4__winrecs__log___getStamp(), chat4__winrecs__log___userID, chat4__winrecs__log___machineID, getAppFileName(),
	chat4__winrecs__log___getCaller()
) +s +"\n\n"
; Standardize any CR/LF characters in buf before writing.
let buf = stringReplaceChars(buf, "\r\n", "\n")
let buf = stringReplaceSubstrings(buf, "\n", "\r\n")
chat4__winrecs__log___logstream.write(buf)
return True
endFunction

int function chat4__winrecs__log__isOpen()
; Returns True if the log file is open and False if not.
; "Open" here means can be written to but may not necessarily mean the file is physically opened at the moment.
if chat4__winrecs__log___fileName then
	return True
endIf
return False
endFunction

object function util__newCollection()
; Return something permitting storage of a collection of data items.
; This is here to simplify migration from JAWS 10 and old 11 to JAWS 11 update 1 and later.
var object coll let coll = createObjectEx("Scripting.Dictionary", False)
let coll.CompareMode = 1  ; TextCompare
return coll
endFunction

int function roomtree___navNext(object o, int childID, int forward, int byAge, int skipThisOne)
; Return the next childID in the requested direction and sort order.
; If skipThisOne is True, the given node is not considered, otherwise it is.
; For byAge True, assumes roomtree___firstID and roomtree___lastID are set.
; Helper for roomtree__getMember().
var int dir
if byAge then
	if forward then
		let dir = 1
	else
		let dir = -1
	endIf
else
	if forward then
		let dir = NavDir_Next
	else
		let dir = NavDir_Previous
	endIf
endIf

while childID
	if !skipThisOne && roomtree__isMember(o, childID) then
		return childID
	endIf
	if byAge then
		let childID = childID +dir
		if childID < roomtree___firstID || childID > roomtree___lastID then
			; We hit an edge of the valid childIDs.
			let childID = 0
		endIf
	else
		let childID = o.accNavigate(dir, childID)
	endIf
	let skipThisOne = False
endWhile
return 0
endFunction

int function roomtree__isMember(object o, int childID)
; Returns True if this is a member node, as opposed to a channel.
var string name, int count
if !o.accRole(childID) then
	; This happens for a skipped childID in byAge navigation.
	return False
elif !roomtree___getNameAndCount(o.accName(childID), name, count) then
	; Unrecognized nodes are called members here.
	beep()
	return True
endIf
return (count == -1)
endFunction

int function roomtree___getNameAndCount(string s, string byRef name, int byRef count)
; Return the name and count from the given channel tree node name text.
; If the text represents a user name and not a channel (no count included),
; the returned count will be -1.
let s = stringTrimLeadingBlanks(stringTrimTrailingBlanks(s))
var int pos let pos = stringContainsFromRight(s, " ")
if !pos || substring(s, pos+1, 1) != "("
|| stringRight(s, 1) != ")" then
	let count = -1
	let name = s
	return True
endIf
let name = stringLeft(s, pos-1)
var string tmp let tmp = stringChopRight(stringChopLeft(s, pos+1), 1)
var int n let n = stringLength(tmp)
var int i let i = 1
while i <= n
	if !stringContains("0123456789", substring(tmp, i, 1)) then
		let name = s
		let count = -1
		return True
	endIf
	let i = i +1
endWhile
let count = stringToInt(tmp)
return True
endFunction

string function roomtree___treePath(object o, int childID)
; Return the path from root to given tree node.
; Omits the given node and the top-level node.
var int safety let safety = 50
var string path let path = ""
var string name, int cnt
while safety
	let childID = o.accNavigate(NavDir_Left, childID)
	if childID && o.accNavigate(NavDir_Left, childID) then
		if !roomtree___getNameAndCount(o.accName(childID), name, cnt) then
			beep()
			return ""
		endIf
		if path then
			let path = ", " +path
		endIf
		let path = name +path
	else
		let safety = 1  ; exits loop
	endIf
	let safety = safety -1
endWhile
return path
endFunction

void function roomtree___sayNode()
; Say the path to the current tree node.
var object tree let tree = roomtree___treeRecord()
if !tree then
	return
endIf
var object o let o = tree("client")
var string path let path = roomtree___treePath(o, o.accFocus)
sayUsingVoice(VCTX_Message, path, OT_Message)
endFunction

; Key Enter

int function _DoubleClick(handle hwnd)
var object o let o = MSAA__objectFromWindow(hwnd)
if !o then
return False
endIf
var int childID let childID = o.accFocus +0
if !childID then
return False
endIf
var int accState let accState = o.accState(childID)
if (accState & (State_System_Invisible | State_System_OffScreen)) then
return False
endIf
var int left, int right, int top, int bottom
if !MSAA__rect(o, childID, left, right, top, bottom) then
return False
endIf
var int x let x = (left +right) /2
var int y let y = (top +bottom) /2
winclick__post(hwnd, "LeftDblClick", x, y)
return True
endFunction

globals
	handle MSAA___lastHwnd,
	int MSAA___lastObjID,
	object MSAA___lastObj

object function MSAA__objectFromWindow(handle hwnd, /*?*/ int objID)
; Return the requested (default ObjID_Client) MSAA object from the given window.
if !stringLength(util__vcast(objID)) then
	let objID = -4  ; ObjID_Client
endIf
if hwnd == MSAA___lastHwnd && objID == MSAA___lastObjID && MSAA___lastObj then
	return MSAA___lastObj
endIf
var object o, int childID
let o = getObjectFromEvent(hwnd, objID, 0, childID)
if !o then
	return o
endIf
let MSAA___lastHwnd = hwnd
let MSAA___lastObjID = objID
let MSAA___lastObj = o
return o
endFunction

variant function util__vcast(variant v)
; Cast any type to variant.
return v
endFunction

int function MSAA__rect(object o, int childID, int byRef left, int byRef right, int byRef top, int byRef bottom)
; Get the bounding rectangle for the given MSAA object and childID.
; The rectangle is returned 1-based, as JAWS likes its rectangles.
; MSAA provides 0-based left/top/width/height.
if !o then
	let left = 0
	let right = 0
	let top = 0
	let bottom = 0
	return False
endIf
if !childID then
	let childID = 0
endIf
o.accLocation(intRef(left), intRef(top), intRef(right), intRef(bottom), childID)
if !left && !right && !top && !bottom then
	return False
endIf
; but we want 1-based left/right/top/bottom.
let left = left +1
let top = top +1
let right = left +right
let bottom = top +bottom
return True
endFunction

void function winclick__post(handle hwnd, string which, /*?*/ int x, int y)
; Send a click to the given window using a sendMessage() call.
; hwnd: The window to which to send an event.
; which: Which event and keys to include.  Click specifiers:
;	Left, Right, or Middle:  Which button to use for a click.
;	dbl (optional):  Include if you want a double click.
;	Click (optional):  Not required.
;	Hover: Use in place of the above to cause a hover event instead of a click.
;	Leave: Use in place of the above to cause a leave event.
; Examples: leftDblClick, leftClick, leftDbl, left, hover.
; Key specifiers (include zero or more):
;	ctrl or control: A control key is down.
;	shift: A shift key is down.
; x: The x coordinate to click or hover over (optional).
; y: The y coordinate to click or hover over (optional).
; If x and y are not passed or are 0,
; the top left corner of the Window's client area is used.

winclick___doClick(False, hwnd, which, x, y)
endFunction

int function winclick___doClick(int useSend, handle hwnd, string which, /*?*/ int x, int y)
; Send a click to the given window using a sendMessage() or postMessage call.
; See winclick__sendClick() or winclick__postClick() for details on usage.
; Returns the sendMessage() result if sendMessage() is used, or nothing if postMessage() is used.
; Fine print: This function sends two messages, ; one for buttonDown and one for buttonUp.
; The sendMessage result comes from the first of these calls when sendMessage is used.
; Only one message is sent for a hover or leave.
let which = stringLower(which)
var int msgDown, int msgUp
var int wParam let wParam = 0
if stringContains(which, "hover") then
	let msgDown = 0x02A1  ; WM_MOUSEHOVER
	let msgUp = 0  ; skip that one.
elif stringContains(which, "leave") then
	let msgDown = 0x02A3  ; WM_MOUSELEAVE
	let msgUp = 0  ; skip that one.
elif stringContains(which, "left") then
	if stringContains(which, "dbl") then
		let msgDown = 0x0203  ; WM_LBUTTONDBLCLK
	else
		let msgDown = 0x0201  ; WM_LBUTTONDOWN
	endIf
	let msgUp = 0x0202  ; WM_LBUTTONUP
	let wParam = wParam | 1  ; MK_LBUTTON
elif stringContains(which, "right") then
	if stringContains(which, "dbl") then
		let msgDown = 0x0206  ; WM_RBUTTONDBLCLK
	else
		let msgDown = 0x0204  ; WM_RBUTTONDOWN
	endIf
	let msgUp = 0x0205  ; WM_RBUTTONUP
	let wParam = wParam | 2  ; MK_RBUTTON
elif stringContains(which, "middle") then
	if stringContains(which, "dbl") then
		let msgDown = 0x0209  ; WM_MBUTTONDBLCLK
	else
		let msgDown = 0x0207  ; WM_MBUTTONDOWN
	endIf
	let msgUp = 0x0208  ; WM_MBUTTONUP
	let wParam = wParam | 0x10  ; MK_MBUTTON
else
	beep()
	return False
endIf
if stringContains(which, "shift") then
	let wParam = wParam | 4  ; MK_SHIFT
endIf
if stringContains(which, "ctrl") || stringContains(which, "control") then
	let wParam = wParam | 8  ; MK_CONTROL
endIf
var int lParam let lParam = 0
if x || y then
	if !msgUp then
		saveCursor()  JAWSCursor()  saveCursor()
		moveTo(x, y)
	endIf
	var int left, int right, int top, int bottom
	; -4 is ObjID_Client
	if MSAA__windowRect(hwnd, -4, left, right, top, bottom) then
		let x = x -left
		let y = y -top
	else
		let x = x -getWindowLeft(hwnd)
		let y = y -getWindowTop(hwnd)
	endIf
	let lParam = makeLong(x, y)
endIf
var int result
if useSend then
	let result = sendMessage(hwnd, msgDown, wParam, lParam)
	if msgUp then
		sendMessage(hwnd, msgUp, 0, lParam)
	endIf
else
	postMessage(hwnd, msgDown, wParam, lParam)
	if msgUp then
		postMessage(hwnd, msgUp, 0, lParam)
	endIf
endIf
if !msgUp then
	pause()
endIf
return result
endFunction

int function MSAA__windowRect(handle hwnd, int objID, int byRef left, int byRef right, int byRef top, int byRef bottom)
; Return by reference the rectangle for the given object ID in the given window.
; Returns True on success and False on failure.
let left = 0
let right = 0
let top = 0
let bottom = 0
var object o, int childID
let o = getObjectFromEvent(hwnd, objID, 0, childID)
if !o then
	return False
endIf
if !MSAA__rect(o, 0, left, right, top, bottom) then
	return False
endIf
return True
endFunction

script DoEnter()
; Makes Enter join a room if focus is on a room line or on someone within one.
var handle hwnd let hwnd = getFocus()
if GetWindowClass (hWnd) == "RichEdit20W" then
PlaySound (GetSharedSettingsDirectory ()+"\\SOUNDS\\ascend.wav")
endif
if getWindowClass(hwnd) == "SysTreeview32" then
	if _DoubleClick(hwnd) then
		return
	endIf
	beep()
endIf
typeCurrentScriptKey()
sayCurrentScriptKeyLabel()
endScript

; hot keys scenario
Script hotkeyhelp ()
If UserBufferIsActive () then
UserBufferDeactivate ()
EndIf
SayFormattedMessage (OT_USER_BUFFER, msghelp, msghelp)
EndScript

Script ProgramKey ()
TypeCurrentScriptKey ()
EndScript

; Insert smiles
Script InsertSmiles ()
var
string SmilesName,
string smile,
String SmilesIniFile,
int choice
let SmilesIniFile =GetJAWSSettingsDirectory () + "\\TeamTalk4Classic.ini"
let SmilesName = IniReadSectionKeys ("SmilesName", SmilesIniFile)
let choice = DlgSelectItemInList (SmilesName, " ", 0, 1)
if choice then
let smilesName = StringSegment (SmilesName, "|", choice)
Let Smile = IniReadString ("SmilesName", SmilesName, "", SmilesIniFile) 
TypeString (" " +smile)
endif
EndScript

; conservation is audio to actuate and switch off
Script StoreAudio  ()
Var
Handle hWnd

TypeKey ("Insert+3")
TypeKey ("Ctrl+Alt+A")
Pause ()
Let hWnd = FindDescendantWindow (GetParent (GetFocus ()), 1364)
If (hWnd) Then
SpeechOff ()
PostMessage (hWnd, BM_CLICK)
Pause ()
Let hWnd = FindDescendantWindow (GetParent (GetFocus ()), 1)
Pause ()
PostMessage (hWnd, WM_LBUTTONDOWN, 0)
PostMessage (hWnd, WM_LBUTTONUP, 0)
;Pause ()
PlaySound (GetSharedSettingsDirectory ()+"\\SOUNDS\\BlindsDownOnly.wav")
SpeechOn ()
Say ("", ot_message)
Return true
EndIf
Say (" ", ot_message)
EndScript

; Say a file name
Script SayNameFile ()
var
Handle hWnd

Let hWnd = GetFocus ()
If GetWindowClass (hWnd) == "Button" Then
Let hWnd = FindDescendantWindow (GetForegroundWindow (), 1255)
Say (" " + GetWindowText (hWnd, false), ot_message)
endif
EndScript

; Say a size of the file
Script SaySizeFile ()
var
Handle hWnd,
String symbol,
String s

Let hWnd = GetFocus ()
if GetWindowClass (hWnd) == "Button" then
Let hWnd = FindDescendantWindow (GetForegroundWindow (), 1050)
Let s = GetWindowText (hWnd, false)
Let symbol = StringLeft (StringSegment (s, cScSpace, -1), 1)
Say ("", ot_message)
If symbol == "B" Then
SayLoading (StringSegment (s, cScSpace, 1))
ElIf symbol == "K" Then
SayLoading (IntToString (StringToInt (StringSegment (s, cScSpace, 1)) * 1024))
Else
Say (s, ot_message)
endif
EndIf
EndScript

; Say a size of the jumped file from the general size of the file
Script SaySizeLoading ()
var
Handle hWnd,
String s

Let hWnd = GetFocus ()
if GetWindowClass (hWnd) == "Button" then
Let hWnd = FindDescendantWindow (GetForegroundWindow (), 1254)
Let s = StringSegment (GetWindowText (hWnd, false), cScSpace, 1)
Say (" ", ot_message)
SayLoading (StringSegment (s, "/", 1))
Say ("", ot_message)
SayLoading (StringSegment (s, "/", 2))
endif
EndScript

; Say a percent of the jumped file
Script SayPercentLoading ()
var
Handle hWnd,
String s

Let hWnd = GetFocus ()
if GetWindowClass (hWnd) == "Button" then
Let hWnd = FindDescendantWindow (GetForegroundWindow (), 1254)
Let s = StringSegment (StringSegment (GetWindowText (hWnd, false), "-", 2), ".", 1) + "%"
Say (" " +s, ot_message)
endif
EndScript

; Say a velocity of  file
Script SaySpeedLoading ()
var
Handle hWnd,
String s

Let hWnd = GetFocus ()
if GetWindowClass (hWnd) == "Button" then
Let hWnd = FindDescendantWindow (GetForegroundWindow (), 1192)
Let s = GetWindowText (hWnd, false)
Say (" " + StringSegment (s, ",", 1), ot_message)
endif
EndScript

	Void Function SayLoading (String s)
Var
String ost,
Int n,
Int k,
Int r

Let n = StringToInt (s)
If n >= 1048576 Then
Let k = n / 1048576
Let r = n - k * 1048576
Let r = r * 10 / 1048576
Let ost = " "
ElIf n >= 1024 Then
Let k = n / 1024
Let r = n - k * 1024
Let r = r * 10 / 1024
Let ost = ""
ElIf n< 1024 Then
Let k = n
Let ost = ""
EndIf
If r >= 5 Then
Let k = k + 1
EndIf
SayInteger (k)
Say (ost, ot_message)
EndFunction

Script MinimizeWindow ()
SendMessage (GetAppMainWindow (GetCurrentWindow ()), 274, 61472, 0)
PlaySound (GetSharedSettingsDirectory ()+"\\sounds\\CameraShutter1.wav")
Say ("  ", ot_message)
EndScript

Script SeTTree ()
SpeechOff ()
Let nik = 1
TypeKey ("F4")
EndScript

Script SetChatFiles ()
Var
Handle hWnd

let hWnd = FindWindow (GetAppMainWindow (GetCurrentWindow ()), "SysTabControl32", "")
If (hWnd) Then
If FindString (hWnd, StringSegment (vk, ";", StringContains ("cf", StringLower (StringRight (GetCurrentScriptKeyName (), 1)))), 0, 0) Then
Pause ()
LeftMouseButton ()
PCCursor ()
SetFocus (hWnd)
EndIf
EndIf
EndScript

Script LockedAllRoom ()
Var
Handle hWnd

Let hWnd = GetFocus ()
If GetWindowClass (hWnd) == "SysTreeView32" Then
If Not StringIsBlank (gRoom) && FindGraphic (hWnd, gRoom, S_TOP, S_UNRESTRICTED) Then
RoutePCToJaws ()
TypeKey ("LeftArrow")
EndIf
PCCursor ()
Return
EndIf
Say ("  ", ot_message)
		EndScript

Script SayNewMessage ()
If (IsSameScript ()) then
CopyToClipboard (inform)
SayMessage (ot_user_requested_information,"  ")
Return
EndIf
Say (inform, ot_message)
EndScript

String Function GetBottomLineOfWindow(handle hWnd)
var
 int iLeft,
 int iTop,
 int iRight,
 int iBottom

GetWindowRect(hWnd,iLeft,iRight,iTop,iBottom)
let sWinText =
GetTextInRect(iLeft,iTop,iRight,iBottom,0,IgnoreColor,IgnoreColor,1,0)
Return sWinText
EndFunction

Script ChangeStateWindow ()
Var
String state

If iWnd == 61488 Then
Let iWnd = 61728
Let state = " "
ElIf iWnd == 61728 Then
Let iWnd = 61488
Let state = " "
EndIf
SendMessage (GetAppMainWindow (GetCurrentWindow ()), 274, iWnd, 0)
Say (state, ot_message)
EndScript

Script ToggleVerbosity ()
TypeKey ("Control+Alt+s")
Let nFlagEvent = 1
SpeechOff ()
ActivateMenuBar ()
Delay (3)
TypeKey ("RightArrow")
PriorLine ()
PriorLine ()
Pause ()
Let nVerb = GetObjectStateCode ()
Pause ()
ActivateMenuBar ()
Pause ()
SpeechOn ()
Say (". " + StringSegment (verb, ";", nVerb + 1), ot_message)
EndScript

Script ToggleVoiceActivation ()
;TypeKey ("Control+Shift+a")
TypeCurrentScriptKey ()
Let nFlagVoice = 1
SpeechOff ()
TypeKey ("F4")
EndScript

Script TogglePushToTalk ()
;TypeKey ("Control+Shift+t")
TypeCurrentScriptKey ()
Let nFlagPush = 1
SpeechOff ()
TypeKey ("F4")
EndScript

Script UpdatedChannel ()
Let nUpdatedChannel = 1
TypeKey ("Shift+F7")
EndScript

Script RunF2 ()
Let sRxTx = ""
Let ping = ""
TypeKey ("F2")
EndScript

Script SayPing ()
Say (". " + ping, ot_message)
EndScript

Void Function SayHighLightedText (handle hwnd, string buffer)
If GetWindowClass (hWnd) == "Listbox" && GetControlId (hWnd) == 1154 Then
Return true
EndIf
SayHighLightedText (hwnd, buffer)
EndFunction  

Void Function SayNonHighLightedText (handle hwnd, string buffer)
Var
String s,
String str,
Int n,
Int i

If GetWindowClass (hWnd) == "msctls_statusbar32" && GetControlId (hWnd) == 59393 Then

If StringContains (buffer, "Disconnected") Then
TypeKey ("F2")
StopSpeech ()
EndIf

If StringContains (buffer, "Finish") || StringContains (buffer, "Start") Then
Let inform = buffer
Say (buffer, ot_message)
EndIf
If StringContains (buffer, "RX:") Then
Let sRxTx = buffer
EndIf
Let s = StringLeft (buffer, StringContains (buffer, "") -1)
If StringContains (s, "PING:") Then 
Let s = StringSegment (s, cScSpace, -1)
If StringCompare (s, ping, false) Then
Let ping = s
EndIf
EndIf
Return
EndIf

If GetWindowClass (hWnd) == "RichEdit20W" && GetControlID (hWnd) == 1204 Then
Let s = StringSegment (GetWindowText (hWnd, false), "*", -1)
If StringContains (s, "<") Then
Let s = StringSegment (s, "<", -1)
If StringCompare (s, msgChannel, false) Then
Say (StringSegment (s, ">", 1) +"   . " +StringSegment (s, ">", 2), ot_message)
Let msgChannel = s
Let Inform = s
EndIf
EndIf
Return true
EndIf

If GetWindowClass (hWnd) == "RichEdit20W" && GetControlId (hWnd) == 1138 Then
GetBottomLineOfWindow(hWnd)
Let n = StringSegmentCount (sWinText, "\n")
Let s = StringSegment (sWinText, "\n", 1) + " . "
Let i = 1
While i <= n 
Let i = i + 1
Let str = StringSegment (sWinText, "\n", i) +"'"
If !StringContains (str, ":'") Then
Let s = s + str
Else
let i = n
EndIf
EndWhile
Pause ()
Let s = StringReplaceSubstrings (s, "'", cScSpace)
If StringCompare (s, inform, false) Then
Say (s, ot_message)
Let inform = s
EndIf
Return True
EndIf
SayNonHighLightedText (hwnd, buffer)
EndFunction 

int Function HandleCustomWindows (handle hWnd)
Var
Handle hWnd1,
String sNik

If GetWindowClass (hWnd) == "Edit" && GetControlId (hWnd) == 1206 Then
Say (msgChannelMessageInput, ot_message)
Return true
EndIf

If GetWindowClass (hWnd) == "Edit" && GetWindowName (hWnd) == "" && nik == 1 Then
Let sNik = GetWindowText (hWnd, false)
TypeKey (cksEscape)
Pause ()
SetFocus (FindDescendantWindow (GetForegroundWindow (), 1014))
TypeString (sNik)
Pause ()
Let nik = 0
SpeechOn ()
EndIf

If GetWindowClass (hWnd) == "Edit" && GetControlId (hWnd) == 1031 && nUpdatedChannel == 1 Then
Let hWnd1 = FindDescendantWindow (GetForegroundWindow (), 1303)
PostMessage (hWnd1, BM_CLICK)
Let nVerb = SendMessage (hWnd1, 240)
Let hWnd1 = FindDescendantWindow (GetParent (GetFocus ()), 1)
PostMessage (hWnd1, WM_LBUTTONDOWN, 0)
PostMessage (hWnd1, WM_LBUTTONUP, 0)
Pause ()
Say ("  . " + StringSegment (verb, ";", 2 - nVerb), ot_message)
Let nUpdatedChannel = 0
Return true
EndIf

If GetWindowClass (hWnd) == "Edit" && GetControlId (hWnd) == 1052 && nFlagVoice == 1 Then
Let nVerb = SendMessage (FindDescendantWindow (GetForegroundWindow (), 1056), 240)
PostMessage (FindDescendantWindow (GetForegroundWindow (), 2), BM_CLICK)
Let nFlagVoice = 0
SpeechOn ()
Pause ()
Say (" . " + StringSegment (verb, ";", nVerb + 1), ot_message)
Return true
EndIf

If GetWindowClass (hWnd) == "Edit" && GetControlId (hWnd) == 1052 && nFlagPush == 1 Then
Let nVerb = SendMessage (FindDescendantWindow (GetForegroundWindow (), 1054), 240)
PostMessage (FindDescendantWindow (GetForegroundWindow (), 2), BM_CLICK)
Let nFlagPush = 0
SpeechOn ()
Pause ()
Say (",  . " + StringSegment (verb, ";", nVerb + 1), ot_message)
Return true
EndIf

If GetWindowClass (hWnd) == "Button" && (GetWindowName (GetParent (hWnd)) == "  " || GetWindowName (GetParent (hWnd)) == "  " || GetWindowName (GetParent (hWnd)) == "    ") && GetWindowClass (GetPriorWindow (hWnd)) == "Edit" Then
Say (" ", ot_message)
EndIf
If GetWindowClass (hWnd) == "Button" && (GetWindowName (GetPriorWindow (hWnd)) == "  " || GetWindowName (GetPriorWindow (hWnd)) == "Folder for audio files") Then
Say (" ", ot_message)
EndIf
If GetWindowClass (hWnd) == "Button" &&( (GetWindowName (hWnd) == " " || GetWindowName (hWnd) == "Clear") 
|| GetWindowName (GetPriorWindow (GetPriorWindow (hWnd))) == "") Then
Say (GetWindowName (GetPriorWindow (GetPriorWindow (hWnd))), ot_message)
EndIf

If GetWindowClass (hWnd) == "Button" && (GetWindowName (hWnd) == "" || GetWindowName (hWnd) == "OK") && GetWindowClass (GetParent (hWnd)) == "#32770" && (GetWindowName (GetParent (hWnd)) == "TeamTalk5Classic" || GetWindowName (GetParent (hWnd)) == " ") Then
Let inform = StringChopRight (GetWindowText (GetParent (hWnd), false), 3)
Pause ()
EnterKey ()
Return true
EndIf

If GetWindowClass (hWnd) == "msctls_trackbar32" && GetControlID (hWnd) == 1002 Then
Say ("  " + GetObjectValue (), ot_message)
Return true
EndIf

If GetWindowClass (hWnd) == "msctls_trackbar32" && GetControlID (hWnd) == 1342 Then
Say ("  " + GetObjectValue (), ot_message)
Return true
EndIf

EndFunction 

int Function HandleCustomRealWindows (handle hWnd)
If GetWindowClass (hWnd) == "#32770" && GetWindowName (hWnd) == " " && nUpdatedChannel == 1 
|| GetWindowClass (hWnd) == "#32770" && GetWindowName (hWnd) == " " Then
Return True
EndIf
EndFunction

Script ToggleSilenceChannel ()
Var
Int nSilence

TypeKey ("Control+M")
SpeechOff ()
ActivateMenuBar ()
Delay (2)
TypeString ("")
EnterKey ()
PriorLine ()
PriorLine ()
Pause ()
Let nSilence = GetObjectStateCode ()
Pause ()
ActivateMenuBar ()
Pause ()
SpeechOn ()
Say (". " + StringSegment (verb, ";", nSilence + 1), ot_message)
EndScript

Script ToggleVoiceUser ()
Var
Int nSilence,
String s

TypeKey ("Control+Shift+M")
Let s = GetToEndOfLine ()
SpeechOff ()
ActivateMenuBar ()
Delay (2)
TypeString ("")
EnterKey ()
TypeString ("")
EnterKey ()
Pause ()
Let nSilence = GetObjectStateCode ()
Pause ()
ActivateMenuBar ()
Pause ()
SpeechOn ()
Say (s, ot_message)
If nSilence != 1 && nSilence !=0 Then
Say ("", ot_message)
Return
EndIf
Say (". " + StringSegment (verb, ";", 2 - nSilence), ot_message)
If nSilence == 1 Then
Let VoiceNone = VoiceNone + s + ";"
ElIf nSilence == 0 Then
Let VoiceNone = StringReplaceSubstrings (VoiceNone, s + ";", "")
EndIf
EndScript

Script ToggleMediaFile ()
Var
Int nSilence

;TypeKey ("Control+Alt+M")
SpeechOff ()
ActivateMenuBar ()
Delay (2)
TypeString ("")
EnterKey ()
TypeString ("")
EnterKey ()
PriorLine ()
Pause ()
Let nSilence = GetObjectStateCode ()
Pause ()
EnterKey ()
Pause ()
SpeechOn ()
If nSilence != 1 && nSilence !=0 Then
Say ("", ot_message)
Return
EndIf
Say (" . " + StringSegment (verb, ";", nSilence +1), ot_message)
EndScript

Script SayVoiceNone ()
If IsSameScript () Then
Let VoiceNone = ""
Else
Say (VoiceNone, ot_message)
EndIf
EndScript

Void Function FocusChangedEventEx (Handle hFocus)
If GetWindowClass (hFocus) == "SysTreeView32" then
Say (GetObjectValue (), ot_message)				
If StringContains (GetLine (), "talking") && GetWindowType (hFocus) == "" Then
SayToCursor ()
EndIf
Return true
EndIf
If GetWindowClass (hFocus) == "SysListView32" || GetWindowClass (hFocus) == "Listbox" then
SayLine ()
Return true
EndIf
FocusChangedEventEx (hFocus)
EndFunction

Script SetEdit ()
Var
Handle hWnd

Let hWnd = FindDescendantWindow (GetForegroundWindow (), 1251)
Let hWnd = GetNextWindow (GetFirstChild (hWnd))
Let hWnd = FindDescendantWindow (hWnd, 1206)
If (hWnd) Then
PostMessage (hWnd, WM_LBUTTONDOWN, 0)
PostMessage (hWnd, WM_LBUTTONUP, 0)
Return true
EndIf
EndScript

Script SaySpeedRxTx ()
Var
Handle hWnd,
String str,
Int i

Let i = StringToInt (StringRight (GetCurrentScriptKeyName (), 1))
let hWnd = FindWindow (GetAppMainWindow (GetCurrentWindow ()), "msctls_statusbar32", "")
If (hWnd) Then
Let str = sRxTx
If StringContains (str, "RX:") Then
Let str = StringReplaceSubstrings (str, "KB", "  |")
Let str = StringSegment (str, "|", i)
Let str = StringSegment (rxtx, ";", i) + StringSegment (str, ":", 2) 
Say (str, ot_message)
EndIf
EndIf
EndScript


Script CopyComment ()
Var
String s

If GetWindowClass (GetFocus ()) == "SysTreeView32" Then
Let s = GetObjectValue ()
If StringContainsChars (s, "()") Then
Let s = StringSegment (StringSegment (s, "(", 2), ")", 1)
CopyToClipboard (s)
Say ("", ot_message)
EndIf
EndIf
EndScript

Script MessageChannel ()
Var
Handle hWnd

If GetWindowClass (GetFocus ()) == "SysTreeView32" Then
let hWnd = FindWindow (GetAppMainWindow (GetCurrentWindow ()), "SysTabControl32", "")
Let hWnd = GetNextWindow (GetFirstChild (hWnd))
Let hWnd = FindDescendantWindow (hWnd, 1206)
SetFocus (hWnd)
EndIf
EndScript

Script WhoTalk ()
TypeCurrentScriptKey ()
EndScript



